//-------------------------------------------------------------------------------------------------+
// PersonDetection.h
// Define PersonDetection class that detects person by using LRF data and Global map
//-------------------------------------------------------------------------------------------------+

#ifndef __MAPTOIMAGE__
#define __MAPTOIMAGE__

#include "LaserRangeSensorDataStub.h"
#include "MRFCStub.h"
#include "IIS2Stub.h"
#include "AislGlobalPlanningStub.h"

#include "cv.h"
#include "highgui.h"
#include <vector>

using namespace std;


//-------------------------------------------------------------------------------------------------+
// ߖT̒`i4ߖTE8ߖTj
//-------------------------------------------------------------------------------------------------+
enum Neighbor{ NEIGHBOR4, NEIGHBOR8	};


//-------------------------------------------------------------------------------------------------+
// WNX
//-------------------------------------------------------------------------------------------------+
class intCoordinate{
public:
	int x, y;
	intCoordinate(){ x = y = 0; }
	intCoordinate( int x, int y ){ this->x = x; this->y = y; }
};


//-------------------------------------------------------------------------------------------------+
// WNX
//-------------------------------------------------------------------------------------------------+
class floatCoordinate{
public:
	float x, y;
	floatCoordinate(){ x = y = 0.0; }
	floatCoordinate( float x, float y ){ this->x = x; this->y = y; }
};


//-------------------------------------------------------------------------------------------------+
// n}f[^摜𐶐NX
//-------------------------------------------------------------------------------------------------+
class PersonDetection{
private:
	double x_scale, y_scale, origin_x, origin_y;

public:
	IplImage *image;

	PersonDetection(){ image = 0; x_scale = y_scale = 1.0; }
	PersonDetection( const PersonDetection& obj ){ image = 0; }
	~PersonDetection(){ if( image ) cvReleaseImage( &image ); }

	TUT::TimedPersonsGlobalPosition ExtractPerson( SensorRTC::LaserRangeSensor::idl::MeasuredData rangedata, RTC::Pose2D pose );
	void DrowMap( MRFC::TimedFloatAbsoluteOGMapData *mapdata, float threshold, double scale=1.0 );
	void DrowMap( MRFC::TimedAbsoluteOGMapData *mapdata, int threshold, double scale=1.0 );

private:
	void DrowFloatMap( IplImage *img, MRFC::TimedFloatAbsoluteOGMapData *mapdata, float threshold );
	void DrowOctetMap( IplImage *img, MRFC::TimedAbsoluteOGMapData *mapdata, int threshold );
	void DrowRangeData( IplImage *img, SensorRTC::LaserRangeSensor::idl::MeasuredData rangedata, RTC::Pose2D pose );
	void Put( IplImage *img, int x, int y, int value=0 );
	void Segment( IplImage *img, double x, double y, double heading, double length, int value=0 );
	void ConnectLine( IplImage *img, double x1, double y1, double x2, double y2, int value=0 );
	int Convert( double x );
	int Convert( double y, int height );
	double ReConvert( double x );
	double ReConvert( double y, int height );
	floatCoordinate EraseArea( IplImage *img, int x, int y, Neighbor neighbor, int *size );
	vector<floatCoordinate> ImageExOr( IplImage *img1, IplImage *img2, Neighbor neighbor );
};


#endif //__MAPTOIMAGE__
